unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TSRec = Class
    Data: String;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function KeyHash(aString: String): Integer;
var
  I, StringLen: Integer;
begin
  Result := 0;
  StringLen:= Length(aString);
  for i := 1 to StringLen do
    Result := Result + Ord(aString[i]);
end; { KeyHash }

function Compare(Item1, Item2: Pointer):Integer;
begin
  if KeyHash(TSRec(Item1).Data) < KeyHash(TSRec(Item2).Data) then Result:= -1 else
  if KeyHash(TSRec(Item1).Data) = KeyHash(TSRec(Item2).Data) then Result:= 0 else
  if KeyHash(TSRec(Item1).Data) > KeyHash(TSRec(Item2).Data) then Result:= 1;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  InFile, OutFile, TokenFile: TextFile;
  List: TList;
  SRec: TSRec;
  TextString: String;
  I: Integer;
begin
  if OpenDialog1.Execute then
  begin
    AssignFile(InFile, OpenDialog1.FileName);
    Reset(InFile);
    AssignFile(OutFile, 'OutPut.txt');
    Rewrite(OutFile);
    AssignFile(TokenFile, 'TokenFile.txt');
    Rewrite(TokenFile);
    List:= TList.Create;
    while not eof(InFile) do
    begin
      Readln(InFile, TextString);
      SRec:= TSRec.Create;
      SRec.Data:= TextString;
      List.Add(SRec);
    end;
    List.Sort(Compare);
    For I:= 0 to List.Count -1 do
    begin
      TextString:= TSRec(List[I]).Data;
      TextString:= 'ctk' +TextString;
      writeln(TokenFile, TextString)
    end;
    For I:= 0 to List.Count -1 do
    begin
      TextString:= TSRec(List[I]).Data;
      TSRec(List[I]).Free;
      TextString:= '    ' +IntToStr(KeyHash(TextString)) + ': if aToken = ' +#39 + TextString +#39+ ' then Result:= ctk' +TextString+';';
      writeln(OutFile, TextString)
    end;
    CloseFile(InFile);
    CloseFile(OutFile);
    CloseFile(TokenFile);
  end;
end;

end.
